Package org.apache.cxf.configuration.jsse

# Class TLSParameterBase

java.lang.Object
org.apache.cxf.configuration.jsse.TLSParameterBase

Direct Known Subclasses:
  `TLSClientParameters`, `TLSServerParameters`

public class TLSParameterBase extends Object
This class is the base class for SSL/TLS parameters that are common to both client and server sides.

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected String`
  `certAlias`
  `protected org.apache.cxf.configuration.security.CertificateConstraintsType`
  `certConstraints`
  `protected org.apache.cxf.configuration.security.FiltersType`
  `cipherSuiteFilters`
  `protected List<String>`
  `ciphersuites`
  `protected static final Collection<String>`
  `DEFAULT_HTTPS_PROTOCOLS`
  `protected KeyManager[]`
  `keyManagers`
  `protected List<String>`
  `namedGroups`
  `protected String`
  `protocol`
  `protected String`
  `provider`
  `protected SecureRandom`
  `secureRandom`
  `protected TrustManager[]`
  `trustManagers`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `TLSParameterBase()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `getCertAlias()`
  This parameter retrieves the cert alias specified on server side
  `org.apache.cxf.configuration.security.CertificateConstraintsType`
  `getCertConstraints()`
  Get the certificate constraints type
  `List<String>`
  `getCipherSuites()`
  Returns the CipherSuites associated with this endpoint.
  `org.apache.cxf.configuration.security.FiltersType`
  `getCipherSuitesFilter()`
  Returns the cipher suites filter
  `String`
  `getJsseProvider()`
  Return the JSSE provider.
  `KeyManager[]`
  `getKeyManagers()`
  Returns the key managers for the endpoint.
  `List<String>`
  `getNamedGroups()`
  Returns the configured TLS named groups list.
  `SecureRandom`
  `getSecureRandom()`
  Returns the secure random algorithm.
  `String`
  `getSecureSocketProtocol()`
  Returns the secure socket protocol in use.
  `TrustManager[]`
  `getTrustManagers()`
  Returns the TrustManagers associated with the endpoint.
  `final void`
  `setCertAlias(String ctAlias)`
  This parameter configures the cert alias used on server side this is useful when keystore has multiple certs
  `final void`
  `setCertConstraints(org.apache.cxf.configuration.security.CertificateConstraintsType constraints)`
  Set the certificate constraints type
  `final void`
  `setCipherSuites(List<String> cs)`
  This parameter sets the cipher suites list to use.
  `final void`
  `setCipherSuitesFilter(org.apache.cxf.configuration.security.FiltersType filters)`
  This parameter sets the filter to include and/or exclude the cipher suites to use from the set list or system defaults.
  `final void`
  `setJsseProvider(String prov)`
  Set the JSSE provider.
  `final void`
  `setKeyManagers(KeyManager[] keyMgrs)`
  Sets the KeyManagers for this endpoint.
  `final void`
  `setNamedGroups(List<String> groups)`
  Sets the ordered list of TLS named groups (key-exchange groups) to offer during the handshake, e.g.
  `final void`
  `setSecureRandom(SecureRandom random)`
  This sets the secure random provider and algorithm.
  `final void`
  `setSecureSocketProtocol(String proto)`
  This sets the protocol to use.
  `final void`
  `setTrustManagers(TrustManager[] trustMgrs)`
  Sets the TrustManagers associated with this endpoint.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### DEFAULT_HTTPS_PROTOCOLS

    protected static final Collection<String> DEFAULT_HTTPS_PROTOCOLS

  - ### keyManagers

    protected KeyManager[] keyManagers

  - ### trustManagers

    protected TrustManager[] trustManagers

  - ### provider

    protected String provider

  - ### ciphersuites

    protected List<String> ciphersuites

  - ### cipherSuiteFilters

    protected org.apache.cxf.configuration.security.FiltersType cipherSuiteFilters

  - ### certConstraints

    protected org.apache.cxf.configuration.security.CertificateConstraintsType certConstraints

  - ### secureRandom

    protected SecureRandom secureRandom

  - ### protocol

    protected String protocol

  - ### certAlias

    protected String certAlias

  - ### namedGroups

    protected List<String> namedGroups

- ## Constructor Details

  - ### TLSParameterBase

    public TLSParameterBase()

- ## Method Details

  - ### setJsseProvider

    public final void setJsseProvider(String prov)
    Set the JSSE provider. If not set, it uses system default.

  - ### getJsseProvider

    public String getJsseProvider()
    Return the JSSE provider.

  - ### setKeyManagers

    public final void setKeyManagers(KeyManager[] keyMgrs)
    Sets the KeyManagers for this endpoint. This parameter may be set to null for system default behavior.

  - ### getKeyManagers

    public KeyManager[] getKeyManagers()
    Returns the key managers for the endpoint.

  - ### setTrustManagers

    public final void setTrustManagers(TrustManager[] trustMgrs)
    Sets the TrustManagers associated with this endpoint. This parameter may be set to null for system default behavior.

  - ### getTrustManagers

    public TrustManager[] getTrustManagers()
    Returns the TrustManagers associated with the endpoint.

  - ### setCipherSuites

    public final void setCipherSuites(List<String> cs)
    This parameter sets the cipher suites list to use. If left unset it uses system defaults.

  - ### getCipherSuites

    public List<String> getCipherSuites()
    Returns the CipherSuites associated with this endpoint.

  - ### setCipherSuitesFilter

    public final void setCipherSuitesFilter(org.apache.cxf.configuration.security.FiltersType filters)
    This parameter sets the filter to include and/or exclude the cipher suites to use from the set list or system defaults.

  - ### getCipherSuitesFilter

    public org.apache.cxf.configuration.security.FiltersType getCipherSuitesFilter()
    Returns the cipher suites filter

  - ### setSecureRandom

    public final void setSecureRandom(SecureRandom random)
    This sets the secure random provider and algorithm. If left unset or set to null, it uses the system default.

  - ### getCertConstraints

    public org.apache.cxf.configuration.security.CertificateConstraintsType getCertConstraints()
    Get the certificate constraints type

  - ### setCertConstraints

    public final void setCertConstraints(org.apache.cxf.configuration.security.CertificateConstraintsType constraints)
    Set the certificate constraints type

  - ### getSecureRandom

    public SecureRandom getSecureRandom()
    Returns the secure random algorithm.

  - ### setSecureSocketProtocol

    public final void setSecureSocketProtocol(String proto)
    This sets the protocol to use. The system default is usually "TLS".

  - ### getSecureSocketProtocol

    public String getSecureSocketProtocol()
    Returns the secure socket protocol in use.

  - ### setCertAlias

    public final void setCertAlias(String ctAlias)
    This parameter configures the cert alias used on server side this is useful when keystore has multiple certs

  - ### getCertAlias

    public String getCertAlias()
    This parameter retrieves the cert alias specified on server side

  - ### setNamedGroups

    public final void setNamedGroups(List<String> groups)
    Sets the ordered list of TLS named groups (key-exchange groups) to offer during the handshake, e.g. `"X25519MLKEM768"`, `"x25519"`. Applied via `SSLParameters.setNamedGroups()` which requires JDK 20+; silently ignored on older JDKs.

  - ### getNamedGroups

    public List<String> getNamedGroups()
    Returns the configured TLS named groups list.